; reni.asm

	list		p=16f1704      ; list directive to define processor
	list		r=dec
	#include	<p16f1704.inc> ; processor specific variable definitions

	__config _config1, _FOSC_INTOSC & _WDTE_OFF & _PWRTE_ON & _MCLRE_OFF & _CP_OFF  & _BOREN_OFF & _CLKOUTEN_OFF & _IESO_OFF  & _FCMEN_OFF
	__CONFIG _CONFIG2, _WRT_OFF & _PLLEN_OFF & _STVREN_OFF & _BORV_LO & _LVP_OFF
	
; Vltozk
	cblock	0x70
	flags	; jelzbitek
	t6popo	; timer6 ut-utoszt
	pab	; port A buffer
	ccbuf
	endc
;aliasok
#define	reload	flags,7	; pergsmentest induljon jra
#define flag1	flags,6	;
#define prev	flags,5
#define	newcc	flags,4	; j rtk van CCP2 szmra 

#define clear	porta,3
#define	jp201	porta,5

#define ttrig	latc,3	;1
#define	duda	latc,5	;3

; makrk
	#include <prlx.inc>

tim1ini	macro	; timer1 a leghosszabb peridussal lldogl
	banksel	t1con
	movl	t1con,34h
	movl	t1gcon,0c0h
	clrf	tmr1h
	clrf	tmr1l
	bcf	pir1,tmr1if
	endm
tim1rst	macro	; timer1 trls (a megszaktst kln kell)
	banksel	t1con
	clrf	tmr1h
	clrf	tmr1l
	endm
tim4ini	macro	; timer4 incializls 1 ms-ra, nem indt 
	banksel	t4con
	movl	t4con,4bh	; 2 volt 1 ms-hoz, most 10 ms
	movl	pr4,07ch
	clrf	tmr4
	banksel	pir2
	bcf	pir2,tmr4if
	endm
tim4rst	macro	; timer4 lellts, trls, a megszaktst is
	banksel	t4con
	bcf	t4con,tmr4on
	clrf	tmr4
	banksel	pir2
	bcf	pir2,tmr4if
	endm
tim4go	macro	; timer4 indts s semmi ms
	banksel	t4con
	bsf	t4con,tmr4on
	endm
tim6ini	macro	; timer6 kb.50 ms, it trls, utut=2, ll
	banksel	t6con
	movl	t6con,7bh
	movl	pr6,0c2h
	clrf	tmr6
	movl	t6popo,2
	banksel	pir2
	bcf	pir2,tmr6if
	endm
tim6rst	macro	; timer6 reset: ll, 0, utut=2, it nem trl!
	banksel	t6con
	bcf	t6con,tmr6on
	clrf	tmr6
	movl	t6popo,2
	endm
tim6go	macro	; timer6 indts s semmi ms
	banksel	t6con
	bsf	t6con,tmr6on
	endm
adcini	macro	; balra tmrt, ra4, ha jl csinltam
	banksel	adcon0
	movl	adcon0,1
	movl	adcon1,50h
	clrf	adcon2
	clrf	adresl
	clrf	adresh
	banksel	0
	bcf	pir1,adif
	endm
; ebben a vltozatban cmp1 kapja a magasabb, cmp2 az alacsonyabb
; + referencit, a bejv jel kzs: in0-=ra1
cmp1ini	macro	; 1. kompartor ra0+ ra1-, inverz kimen polarits
	banksel	cm1con0
	movl	cm1con0,9eh	;invertl
	clrf	cm1con1
	endm
cmp2ini	macro	; 2. kompartor rc0+ ra1-, norml polarits
	banksel	cm2con0
	movl	cm2con0,8eh	; nem invertl
	movl	cm2con1,0
	endm
cmp2tog	macro	; neminv. kompartor kimen polarits megpulzlsa
	banksel cm2con0
	bsf	cm2con0,c2pol
	nop
	nop
	bcf	cm2con0,c2pol
	endm
oscini	macro	; 16 MHz bels, semmi extra
	banksel	osccon
	movl	osccon,7ah
	clrf	oscstat
	clrf	osctune
	endm
ccp1ini	macro	; t=120 ms, compare, egyezsnl felfut lt generl
	banksel	ccp1con
	movl	ccp1con,08h
	movl	ccpr1h, high 60000
	movl	ccpr1l, low 60000
	endm
ccp1rst	macro	; eltte timer1 trlend,hogy elmljon az egyezs!
	banksel	ccp1con
	clrf	ccp1con	; a kimen llapotot gy lehet trlni
	movl	ccp1con,08h	; eredeti zemmd visszalltsa
	endm
ccp2ini	macro	; t=1 ms compare, felfut lt generl
	banksel	ccp2con
	movl	ccp2con,08h
	movl	ccpr2h, high 250
	movl	ccpr2l, low 250
	endm
ccp2rst	macro	; ccp2 jralestse, kicsit vrni kell vele
	banksel	ccp2con
	clrf	ccp2con	; trli a jelzbitet	
	nop
	nop
	nop
	nop
	nop
	nop	; most mr biztosan nincs egyezs
	movl	ccp2con,08h	; eredeti zemmd visszalltsa
	endm
iocini	macro	; IOC ra2 mindkt l, megszaktst nem engedlyez
	banksel	iocaf
	movl	iocan,4
	movwf	iocap
	clrf	iocaf
	clrf	ioccf
	endm
clc3clr	macro	; clc3 szoft trlse pillanatnyi tkonfigurlssal
	banksel	clc3pol
	bsf	clc3pol,2
	nop
	bcf	clc3pol,2
	endm
	
; program
	org	0
	nop
	pagesel	start
	goto	start
; megszakts	
	org	4
	banksel	lata
	bsf	ttrig
	bsf	reload
	bsf	flag1
	banksel	iocaf
	clrf	iocaf
	banksel	0
	bcf	intcon,iocif
	retfie
; fprogram
start
	banksel	lata
	movl	lata,0
	movwf	latc
	banksel	trisa
	movl	trisc,3
	bcf	option_reg,7
	bcf	option_reg,tmr0cs
	banksel	ansela
	movl	ansela,13h
	movl	anselc,3
	banksel	wpua
	movl	wpua,28h
	clrf	wpuc
;perifrik lbkiosztsa
	banksel	RA0PPS
	movlw	H'04'		; lc1out
	movwf	RC4PPS		; RC4-re
	movlw	6		; lc3out
	movwf	rc2pps		; RC2-re
	banksel	t1gpps
	movlw	14h		; RC4, load 
	movwf	t1gpps		; kapuzza tmr1-et
; incializlsok
	oscini
	adcini
	tim1ini
	ccp1ini
	ccp2ini
	tim4ini
	tim6ini
	cmp1ini
	cmp2ini
	iocini
	#include <allclc2.inc>
	clrf	flags
	banksel	0
	movf	porta,w
	movwf	pab	; direkt bemenet beolvassa
	sb	pab,2
	bsf	prev	; invertlsa prev (elz llapot) szmra
	snb	pab,2
	bcf	prev
	bsf	t1con,tmr1on
; mestersges kompartor kimenet: gatyba rzza a piezo csatornt,
	cmp1tog	; ettl clcdata.0 magas lesz (mirt nem lesz?)
	banksel	clcdata
wait1
	snb	clcdata,0
	goto	wait1
; clc1 idztse lejrt, alapllapot visszalltsa
	tim1rst
	ccp1rst
	ccp2rst		;ez indtja az A/D-t
	clc3clr
	clrf	flags
; ha igaz, ez mr az alapllapot, lehet engedlyezni a megszaktst
	bsf	intcon,iocie
	bsf	intcon,peie
	bsf	intcon,gie	; peie nem kell
; s most jnne a mindenre figyel okos hurok
main
	banksel	porta
	jnb	reload,skip1
; l volt a direkt csatornn
	bcf	reload	; flagtrls
	banksel	t4con
	clrf	tmr4	; tmr4 trls (nullrl induljon)
	sb	t4con,tmr4on
	bsf	flag1	; ha mg nem jr, flag1=1
	bsf	t4con,tmr4on	; induljon (ha mr jr, menjen tovbb)
skip1
	banksel	porta
	jnb	pir2,tmr4if,skip2
; pergsmentests lejrt
	tim4rst		; tmr4 lell, megszaktsa trldik, tmr4=0
	banksel	porta 
	movf	porta,w
	movwf	pab	; direkt bemenet beolvassa
	sb	pab,2
	bsf	prev	;inverlsa prev (elz llapot) szmra)
	snb	pab,2
	bcf	prev
	bcf	flag1
	banksel	lata
	sb	pab,2	; lb lltsa (szintn invertlva)
	bsf	ttrig
	snb	pab,2
	bcf	ttrig
skip2
	banksel	0
	jnb	flag1,skip3
; flag1=1, vagyis timer4 pp most indult
	jb	prev,skip3
; de csak ha prev=0 (a stabil szint 1 volt a bemeneten)
	bcf	flag1	; flagtrls
	banksel	lata
	jb	duda,skip3
; s ha mg nem szl a duda
	bsf	duda	; szljon a duda
	tim6go		; s induljon az idztse
skip3
	banksel	porta
	sb	pir2,tmr6if
	goto	skip4
; dudaidzts lejrt
	bcf	pir2,tmr6if	; flagtrls
	decfsz	t6popo,f	; ututoszt cskkents
	goto	skip4
; ututoszt elfogyott:
	banksel	lata
	bcf	duda		; duda elhallgat
	tim6rst		; timer6 lell, trldik
	banksel	porta
	jb	jp201,skip4
; ha jp201 fel van rakva:
	clc3clr		; clc3 (a kombinlt kimenjel) trldik
skip4
	banksel	porta
	jnb	pir2,ccp2if,skip5
; a piezo csatorna ablaka lejrt:
	bcf	pir2,ccp2if	; flagtrls
	ccp2rst		; ccp2 elksztse a kvetkez menetre
	banksel	0
	jb	pir1,adif,skip5
	banksel	adcon0
	bsf	adcon0,go_not_done	; A/D konverzi indtsa
skip5
	banksel	porta
	jnb	pir1,ccp1if,skip6
; piezo vdideje lejrt
	bcf	pir1,ccp1if	; flagtrls
	tim1rst		; timer1 trlse (egyezst is megsznteti)
	jnb	newcc,skip6
	bcf	newcc
	movf	ccbuf,w
	banksel ccpr2h
	movwf	ccpr2h		; ccpr2h mdostsa
	ccp1rst		; ccp1 elksztse a kvetkez menetre		
skip6
	banksel	0
	jnb	pir1,adif,skip7
; A/D konverzi elkszlt
	bcf	pir1,adif	; flagtrls
	banksel	adcon0
	rrf	adresh,f	; adresh transzformlsa
	swapf	adresh,f
	andlw	7
	movwf	ccbuf
	bsf	newcc
skip7
; nincs tbb feladat
	goto	main
; itt a vge
	end	
	 